=== debian/changelog ===
obs-studio (27.2.3+dfsg1-1) unstable; urgency=medium

  * New upstream version 27.2.3+dfsg1

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 06 Mar 2022 18:50:24 +0100

obs-studio (27.2.1+dfsg1-1) unstable; urgency=medium

  * New upstream version 27.2.1+dfsg1

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 27 Feb 2022 10:37:48 +0100

obs-studio (27.2.0+dfsg1-1) unstable; urgency=medium

  * New upstream version 27.2.0+dfsg1
    - Fix build with ffmpeg 5.0 (Closes: #1004639)
  * debian/control: Add Build-Depends on libpci-dev
  * debian/patches: Refresh patches
  * debian/libobs0.symbols: Add new symbols

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 15 Feb 2022 22:44:50 +0100

obs-studio (27.1.3+dfsg1-2) unstable; urgency=medium

  * debian/patches: Apply upstream patch to have Python symbols available
    (Closes: #958966)
  * debian/control: Add missing dependency on libx11-dev

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 23 Nov 2021 00:03:42 +0100
